// GEngine.h: interface for the GEngine class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GENGINE_H__1AA60BBD_B2E7_4250_ADC2_747FA7C90207__INCLUDED_)
#define AFX_GENGINE_H__1AA60BBD_B2E7_4250_ADC2_747FA7C90207__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GBase.h"
#include "GView.h"
#include "TimeManager.h"

class H3DModel;
class GObject;
class GActiveObject;
class GRun;

#define MAX_OBJECTS      30
#define MAX_3D_MODELS    10

// Zakladni objekt hry
// Stara se o vsechno
class GEngine : public GBase  
{
public:

	// obsluha klavesnice
	virtual void KeyDown(Uint8 key);

	// zaradi objekt do fronty na smazani
	void WantBeDeleted(GObject *object_to_delete);

	// smaze objekty, ktere to chteji (jsou v poli m_object_del)
	void DeleteObjects();

	// operace s objekty ve hre - Nekde v tech funkcich by mel byt zabudovany TM
	bool AddObject(GObject *object);
	void RemoveObject(GObject *object);

	// zacne hru - jako parametry ma ty ovladani leveho a praveho hrace
	void StartGame(int control_L, int control_R);

	// vola se vzdy jak to jen jde. Mela by predat rizeni TM
	virtual void TimePassed(int milisec);

	// aktualizuje a prohlidne hru - vyhra,....
	virtual void Move();

	// provede vykresleni cele hry
	virtual void Render();

	// konstrukcne destrukcni rutinky
	GEngine(GRun *run);
	virtual ~GEngine();
	
   // vola se z objektu, ktery chce detekovat svou pripadnou kolizi
   void HitTest(GActiveObject *ob1);
   
   // zkousi, zda je konec hry (dosli zivoty....)
   void TestGameEnd();


	// ukazatel na vsechny objekty ve hre
	GObject    *m_object[MAX_OBJECTS];  // s pevnym ID
	int         m_objects;

	GObject    *m_object_del[MAX_OBJECTS]; // objekty, ktere chteji smazat
	int         m_objects_del;

	// vsechny 3D modely ve hre
	H3DModel *m_3Dmodel[MAX_3D_MODELS];

	// trida zajistujici 3D zobrazovani
	GView    m_view;

	// zajistuje rizeni casovych udalosti
   CTimeManager m_TimeManager;

	// promene herniho stavu
	bool       m_paused; // hra je pauznuta

	// ukazuje na hlavni objekt hry - dulezite, aby slo predat zpet rizeni
	GRun      *m_run;
};

#endif // !defined(AFX_GENGINE_H__1AA60BBD_B2E7_4250_ADC2_747FA7C90207__INCLUDED_)
