// HTextureStore.h: interface for the HTextureStore class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_)
#define AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

 // to je zbytecne moc (alespon doufam)
#define MAX_TEXTURES 100

// Hlida vsechnu textury - obsahuje nacitani, niceni,...........
// pri nekalikanasobnem pozadavku o nacteni stejne textury vraci pokazde
// stejny ukazatel, ale zvysuje pocet uziti textury. Pri pozadavku na odmazani
// textury snizi pocet uziti textury, a kdyz je pocetpouziti == 0, tak teprve texturu
// fyzicky smazne

class HTextureStore  
{
public:
	SDL_Surface* LoadBitmap(const char *filename);
	void SetNullTexture();
	void SetTexture(int ID);
	// vrati id textury, pripadne vytvori novou
	int GetTexture(const char *file, int min_filter, int mag_filter, bool mipmaps);
	// pouziva defaultove parametry
	int GetTexture(const char *file);
	
	// nastavy aktualni texturu podle ID (pro pouzivani)

		HTextureStore();
	virtual ~HTextureStore();
	
  // smazne texturu
  void RemoveTexture(int ID);
  
  // nastavi kvalitu textur - prpustne hodnoty 0, 1, 2
  void SetTextureGeneratingQuality(int quality);

	// informace o 1 texture
	struct st_texture {
		GLuint gl_texture; // vlastni GL textura
		int    used;       // kolikrat je uzita - kolik objektu ji potrebuje
		char   file[100];  // jmeno souboru, ze ktereho je textura
	};

	// data
	st_texture *m_texture[MAX_TEXTURES]; 
	int         m_textures; 

	// default parametry pro tvoreni textur
	bool        m_mipmaps;    // zda se maji generovat mipmapy
	int         m_min_filter; // filtr pro zmensovani
	int         m_mag_filter; // filtr pro zvetsovani


private :
	// vytvori novou texturu - volane z GetTexture
	int CreateTexture(const char* file, int min_filter, int mag_filter, bool mipmaps);
	// fyzicky znici texturu
	void DestroyTexture(int ID);
};

extern HTextureStore htexture;

#endif // !defined(AFX_HTEXTURESTORE_H__45A0CCDB_2291_4DB0_A34C_18FA9A479183__INCLUDED_)
