// MMenu.cpp: implementation of the MMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "ph.h"
#include "MMenu.h"
#include "GRun.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

// statika inicializace
int MMenu::m_control_L = 1;
int MMenu::m_control_R = 0;


MMenu::MMenu(GRun *run)
{
	m_run = run;

   m_back_ground = htexture.GetTexture("menu.jpg");
   m_controls[0] = htexture.GetTexture("menu1.bmp");
   m_controls[1] = htexture.GetTexture("menu2.bmp");
   m_controls[2] = htexture.GetTexture("menu3.bmp");

	m_logo_model.LoadModel("logo.3ds");
	m_model_l.LoadModel("ship2.3ds");
	m_model_r.LoadModel("ship.3ds");
	

	m_rott = 0;
}

MMenu::~MMenu()
{
   htexture.RemoveTexture(m_back_ground);
   htexture.RemoveTexture(m_controls[0]);
   htexture.RemoveTexture(m_controls[1]);
   htexture.RemoveTexture(m_controls[2]);
}

// zobrazi menu (aktualni stav)
void MMenu::Render()
{
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -2.2f);

	// Nastaveni textury pozadi
	htexture.SetTexture(m_back_ground);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( -18.0f,   14.0f, -30.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  18.0f,   14.0f, -30.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  18.0f,  -14.0f, -30.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( -18.0f,  -14.0f, -30.0f);
	glEnd();

	// logo
	glPushMatrix();
	glTranslatef(8.0f, -6.0, -20.0f);
	glRotatef(m_rott, 0.0f, 1.0f, 0.0f);
	glScalef(0.4, 0.4, 0.4);
	m_logo_model.Render();
	glPopMatrix();
	
	// levy hrac
 	glPushMatrix();
	glTranslatef(-7.0f, 0.0, -20.0f);
	glRotatef(m_rott, 0.0f, 1.0f, 0.4f);
	glScalef(1.0, 1.0, 1.0);
	m_model_l.Render();
	glPopMatrix();
	
	// pravi hrac
	glPushMatrix();
	glTranslatef(7.0f, 0.0, -20.0f);
	glRotatef(m_rott, 0.0f, -1.0f, -0.4f);
	glScalef(1.0, 1.0, 1.0);
	m_model_r.Render();
	glPopMatrix();	
	
	

	// Nastaveni textury levy hrac
	htexture.SetTexture(m_controls[m_control_L]);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(  -0.66f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  -0.26f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  -0.26f, -0.4f, 0.1f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(  -0.66f, -0.4f, 0.1f);
	glEnd();

	// Nastaveni textury pravy hrac
	htexture.SetTexture(m_controls[m_control_R]);
 	// otexturovany obdelnik (podklad)
	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(  0.26f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(  0.66f, -0.2f, 0.1f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(  0.66f, -0.4f, 0.1f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(  0.26f, -0.4f, 0.1f);
	glEnd();

}

// reaguje na stisk klavesy
void MMenu::KeyDown(Uint8 key)
{
	switch (key) {
	case SDLK_o:
	   if (++m_control_L > 2) m_control_L = 0;
		break;
	case SDLK_p:
	   if (++m_control_R > 2) m_control_R = 0;
		break;
	case SDLK_ESCAPE:
		m_run->ExitProgram();
		break;
	case SDLK_RETURN:
		if (m_control_L != m_control_R || m_control_R == 2) // aby nebylo stejne ovladanni pro oba
			m_run->StartGame(m_control_L, m_control_R);
		break;
	};
}


void MMenu::TimePassed(int milisec)
{
	m_rott += milisec/8.0f;
}
